--Set up some slash commands to access some functions, mostly for debugging purposes and to allow for functions to be keybound in the client via macros.
SLASH_DIRECTIONAL1 = "/directional"
SLASH_DEFAULTVARS1 = "/defaultvars"
SLASH_UPDATE1 = "/update"
SLASH_QUEST1 = "/qr"

SLASH_COORD1 = "/coord"
--Some local variables to be used to store data between loops.
local currentDirection = "1"
local deg=0.0
local update=1
local lastX = 0
local lastY = 0
local currentX = 0
local currentY = 0
--Function to slim down the process of speaking text through the TTS engine, as well as make it smoother.
local function speakText(spokenMessage)
    C_VoiceChat.StopSpeakingText()
    C_VoiceChat.SpeakText(1, spokenMessage, Enum.VoiceTtsDestination.QueuedLocalPlayback, 5, 100)
end

local function movementTracker()
    local playerPositionX, playerPositionY = UnitPosition("player")
    currentX = math.floor(playerPositionX)
    currentY = math.floor(playerPositionY)
local distX1= currentX-lastX
local distXPow = distX1*distX1
local distY1 = currentY-lastY
local distYPow = distY1*distY1
local distance = (distXPow+distYPow)^.5


    if(distance>=10) then
        PlaySoundFile("Interface/AddOns/WOWAccess-Retail/sounds/movementTic.ogg")
lastX=currentX
lastY=currentY

end
    C_Timer.After(.5, movementTracker)
end

--Function that reads out the player's current coordinates. /coords
    local function readPlayerCoord()
    local map = C_Map.GetBestMapForUnit("player")
    local position = C_Map.GetPlayerMapPosition(map, "player")
local playerMapX, playerMapY = position:GetXY()
    playerMapX = math.floor(playerMapX*10000+0.5)/100
    playerMapY = math.floor(playerMapY*10000+0.5)/100
    local playerPositionX, playerPositionY = UnitPosition("player")
    playerPositionX = math.floor(playerPositionX)
    playerPositionY = math.floor(playerPositionY)
currentX = playerPositionX
currentY = playerPositionY

    speakText(playerMapX..", "..playerMapY)
end

--Function that compares your player's coordinates and the target's coordinates so you know which direction you should face in order to face them. Only works on party members at the moment. Is not linked to any slash commands.
local function readTargetPosition()
    local playerPositionX, playerPositionY = UnitPosition("player")
    local targetPositionX, targetPositionY = UnitPosition("target")
    targetPositionX = math.floor(targetPositionX)
    targetPositionY = math.floor(targetPositionY)
    playerPositionX = math.floor(playerPositionX)
    playerPositionY = math.floor(playerPositionY)
    local direction1 = ""
    local direction2 = ""
    if(targetPositionX < playerPositionX) then
        direction1 = "north"
    else
        direction1 = "South"
    end
    if(targetPositionY < playerPositionY) then
        direction2 = "west"
    else
        direction2 = "east"
    end
speakText(direction1..direction2..", at "..targetPositionY..", "..targetPositionX..".")

end


--This function computes the degrees the player is facing and returns the value as a string.
local function QR()
    local direction="1"

    local facing = math.floor(math.deg(GetPlayerFacing()))
    if(facing >=22 and facing <= 68) then
        direction= "northwest"
    elseif(facing >= 69 and facing <= 112) then
        direction="west"
    elseif(facing >= 113 and facing <= 158) then
        direction="southwest"
    elseif(facing >= 159 and facing <= 202) then
        direction="south"
    elseif(facing >= 203 and facing <= 247) then
        direction="southeast"
    elseif(facing >= 248 and facing <= 292) then
        direction="east"
    elseif(facing >= 293 and facing <= 337) then
        direction="northeast"
    elseif(facing >= 0 and facing <= 21) then
    direction="north"
    elseif(facing >= 338 and facing <= 360) then
        direction="north"
    end
    return direction
    end
--This function compares the players current direction to the most updated direction and if changed, plays the soundfile that is related to the direction.
local function speakDirection()
    local direction = QR()
    if(currentDirection ~= direction) then
        PlaySoundFile("Interface/AddOns/WOWAccess-Retail/sounds/"..direction..".ogg")
        currentDirection=direction
        end
    C_Timer.After(.75, speakDirection)
    end

--A more manageable play function.
local function sp(dir)
    PlaySoundFile("Interface/AddOns/WOWAccess-Retail/sounds/"..dir..".ogg")
end
--Updates the player's current direction
local function DirectionalHandler()
    if(deg >=0 and deg <=10) then
        local dir="north"
        sp(dir)
    elseif(deg >10 and deg <=80) then
        local dir="northwest"
        sp(dir)
    elseif(deg > 80 and deg <=100) then
        local dir="west"
        sp(dir)
    elseif(deg > 100 and deg <= 170) then
        local dir="southwest"
        sp(dir)
    elseif(deg >170 and deg < 190) then
        local dir="south"
        sp(dir)
    elseif(deg > 190 and deg <= 260) then
        local dir="southeast"
        sp(dir)
    elseif(deg > 260 and deg <=280) then
        local dir="east"
        sp(dir)
    elseif(deg > 280 and deg <= 350) then
        local dir="northeast"
        sp(dir)
    elseif(deg > 350) then
        local dir="north"
        sp(dir)
    end
end
--Updates the player's degrees.
local function updateDegrees()
    deg=math.floor(math.deg(GetPlayerFacing()))

    if(update==0) then
        DirectionalHandler()
        C_Timer.After(3, updateDegrees)
    end
    end
local function UpdateTracker()
    if(update == 1) then
        update = 0
    updateDegrees()
    else
        update=1
    end
end

local EventFrame = CreateFrame("frame", "EventFrame")
EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")

EventFrame:SetScript("OnEvent", function(self, event, ...)
	if(event == "PLAYER_ENTERING_WORLD") then
C_Timer.After(1, function() 
updateDegrees()
movementTracker()
speakDirection()
end)
	end
end)
local function DefaultVars()
C_CVar.SetCVar("autoLootDefault", "1")
C_CVar.SetCVar("nameplateMaxDistance", "40")
C_CVar.SetCVar("nameplateShowFriendlyNPCs", "1")
end
--More code for slash commands
SlashCmdList["DIRECTIONAL"] = DirectionalHandler;
SlashCmdList["UPDATE"] = UpdateTracker;
SlashCmdList["QUEST"] = QR;
SlashCmdList["COORD"] = readPlayerCoord;
SlashCmdList["DEFAULTVARS"] = DefaultVars;